#include "Adafruit_NeoPixel.h"
#define N 32
#define LICZBA_DIOD 16
#define PIN 6
int peakL = 0, peakR = 0; // wartość szczytowa w buforze
int diodyL = 0; // liczba diod, które należy zapalic
int diodyR = 0;
int buforL[N], buforR[N]; // bufor w którym znajduje się poprzednie N próbek 
int i = 0, j = 0; // liczniki petli
const float offset=log(1.65); // zlogarytmowana skladowa stala napiecia na mikrofonie
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(LICZBA_DIOD, PIN, NEO_GRB + NEO_KHZ800); // inicjalizacja lancucha diod
void odbierzSygnal(void);
void przeliczPoziom(void);
void zaswiecDiody(void);

void setup() {
  pixels.begin();
}

void loop() {
   odbierzSygnal();
   przeliczPoziom();
   zaswiecDiody();
}
void odbierzSygnal(void){
    peakL = 0;
    peakR = 0;
    buforL[i] = analogRead (A0);
    buforR[i] = analogRead (A1);
    (++i)%=N;
    for(j=0;j<N;j++){
     if (peakL< buforL[j])
       peakL = buforL[j];
     if (peakR< buforR[j]);
       peakR=buforR[j];
    }
  }
void przeliczPoziom(void){
    diodyL = round((log(peakL*(5.0/1023.0))-offset)/0.3*8.0);
    diodyR = round((log(peakR*(5.0/1023.0))-offset)/0.3*8.0);
    if (diodyL > 8)
      diodyL = 8;
    if (diodyR > 8)
     diodyR = 8;
}  
  
void zaswiecDiody(void){
  pixels.clear();
  for(int ii=0; ii<diodyR; ii++){
    pixels.setPixelColor(ii, 63, 0, 63);
    } 
  for(int jj=15; jj>15-diodyL; jj--){
    pixels.setPixelColor(jj, 63, 63, 0);
  }
    pixels.show();
}
  
  
